# Class ClientCnxnSocketNetty

java.lang.Object
org.apache.zookeeper.ClientCnxnSocketNetty

public class ClientCnxnSocketNetty extends Object
ClientCnxnSocketNetty implements ClientCnxnSocket abstract methods. It's responsible for connecting to server, reading/writing network traffic and being a layer between network data and higher level packets.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected ZKClientConfig`
`clientConfig`
`protected ByteBuffer`
`incomingBuffer`
After the length is read, a new incomingBuffer is allocated in readLength() to receive the full message.
`protected boolean`
`initialized`
`protected long`
`lastHeard`
`protected long`
`lastSend`
`protected final ByteBuffer`
`lenBuffer`
This buffer is only used to read the length of the incoming message.
`protected long`
`now`
`protected LinkedBlockingDeque<org.apache.zookeeper.ClientCnxn.Packet>`
`outgoingQueue`
`protected final AtomicLong`
`recvCount`
`protected org.apache.zookeeper.ClientCnxn.SendThread`
`sendThread`
`protected final AtomicLong`
`sentCount`
`protected long`
`sessionId`
The sessionId is only available here for Log and Exception messages.

## Method Summary

Modifier and Type
Method
Description
`protected void`
`initProperties()`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### initialized

protected boolean initialized

### lenBuffer

protected final ByteBuffer lenBuffer
This buffer is only used to read the length of the incoming message.

### incomingBuffer

protected ByteBuffer incomingBuffer
After the length is read, a new incomingBuffer is allocated in readLength() to receive the full message.

### sentCount

protected final AtomicLong sentCount

### recvCount

protected final AtomicLong recvCount

### lastHeard

protected long lastHeard

### lastSend

protected long lastSend

### now

protected long now

### sendThread

protected org.apache.zookeeper.ClientCnxn.SendThread sendThread

### outgoingQueue

protected LinkedBlockingDeque<org.apache.zookeeper.ClientCnxn.Packet> outgoingQueue

### clientConfig

protected ZKClientConfig clientConfig

### sessionId

protected long sessionId
The sessionId is only available here for Log and Exception messages. Otherwise the socket doesn't need to know it.

## Method Details

### initProperties

protected void initProperties() throws IOException

Throws:
  `IOException`